;
; emapp9ppb`
;

	relaxed on

KEYDATA		equ	$8427
GAMEDATA	equ	$8428	; "0" STOP SFT SPC E
CAPSDATA	equ	$842d
GETBYTE		equ	$852f
SETDRWFILE	equ	$8548

; 0xb800`
; ̂܂܎gp
;
	org	$b800
	db	$ff

; 0xb82d`0xb868
; 32x16L`
;
	org	$b82d
DRAW32x16:
	ld	h,a
	ld	a,$26
	cp	b
	ret	c
	ld	l,0
	srl	h
	rr	l		; x128
	ld	de,$0500
	add	hl,de

	ex	de,hl
	call	CALCVRAM
	ex	de,hl

	jp	nz,DRAW32x16_R

DRAW32x16_L:
	ld	b,4
.lp2:
	push	de
	ld	c,5*8
	ld	a,e
.lp1:
	ld	e,a
	ldi
	ldi
	ldi
	ldi
	dec	de
	inc	d

	dec	c		; 4x2hbg݂ c -= 5
	jr	nz,.lp1
	pop	de

	inc	e
	inc	e
	inc	e
	inc	e
	jp	z,DRAW32x16_R_CNT

	djnz	.lp2
	ret

; 0xb869`0xb8ab
; 64x32L`
;
	org	$b869
DRAW64x32:
	ld	h,a
	ld	a,$22
	cp	b
	ret	c
	ld	l,0
	add	hl,hl		; x512
	ld	de,$4100
	add	hl,de

	ex	de,hl
	call	CALCVRAM
	ex	de,hl

	jp	nz,DRAW64x32_R

DRAW64x32_L:
	ld	b,8
.lp2:
	push	de
	ld	c,5*16
	ld	a,e
.lp1:
	ld	e,a
	ldi
	ldi
	ldi
	ldi
	dec	de
	inc	d

	dec	c		; 4x2hbg݂ c -= 5
	jr	nz,.lp1
	pop	de

	inc	e
	inc	e
	inc	e
	inc	e
	jp	z,DRAW64x32_R_CNT

	djnz	.lp2
	ret

; 0xb8ac`0xb8df
; `
; BFYWi/8j
; CFXWi/4j
; HFiWhbgPʁj
; LFcihbgj
;
	org	$b8ac
ERASEHxL:
	ld	a,$2d
	cp	b
	ret	c

	srl	l
	srl	l

	ex	de,hl
	call	CALCVRAM

	ld	b,d		; [v
	ld	c,e		; c[v
	ld	d,$00		; p^[

	jp	nz,ERASEHxL_R

ERASEHxL_L:

.lp2:
	push	hl
	ld	e,c		; c[v
	sla	e
	ld	a,l
.lp1:
	ld	l,a
	ld	(hl),d
	inc	l
	ld	(hl),d
	inc	l
	ld	(hl),d
	inc	l
	ld	(hl),d

	inc	h
	dec	e
	jr	nz,.lp1
	pop	hl

	inc	l
	inc	l
	inc	l
	inc	l
	jp	z,ERASEHxL_R_CNT

	djnz	.lp2
	ret

; 0xb8e0`0xb8f4
; VRAMAhXZo
; BFYWi/8j
; CFXWi/4j
; RETURN
; HLFVRAMAhX
; ZflagF1̎
;
	org	$b8e0
CALCVRAM:
	bit	6,c
	jp	nz,CALCVRAM_R

CALCVRAM_L:
	push	af
	ld	a,b
	add	a,a
	add	a,$1a
	ld	h,a
	ld	a,c
	add	a,a
	add	a,a
	ld	l,a
	pop	af
	ret

; 0xb8f5`
; ̂܂܎gp
;
	org	$b8f5
	db	$ff

; 0xb94d`0xb97d
; Pi16x8j`
;
	org	$b94d
DRAW16x8:
	ld	h,0
	ld	l,a
	add	hl,hl		; x2
	add	hl,hl		; x4
	add	hl,hl		; x8
	add	hl,hl		; x16
	add	hl,hl		; x32

	ex	de,hl
	call	CALCVRAM
	ex	de,hl

	jp	nz,DRAW16x8_R

DRAW16x8_L:
	ld	b,2
.lp2:
	push	de
	ld	c,5*4
	ld	a,e
.lp1:
	ld	e,a
	ldi
	ldi
	ldi
	ldi
	dec	de
	inc	d

	dec	c		; 4x2hbg݂ c -= 5
	jr	nz,.lp1
	pop	de

	inc	e
	inc	e
	inc	e
	inc	e
	jp	z,DRAW16x8_R_CNT

	djnz	.lp2
	ret

; 0xb97e`0xb9aa
; @̒ei8x4j`
; BFYWi/8j
; CFXWi/4j
; DEFp^[AhX
;
	org	$b97e
DRAW4x4:
	call	CALCVRAM
	ex	de,hl

	ld	b,e
	ld	c,$ff

	ld	e,b
	ldi
	ldi
	ldi
	ld	a,(hl)
	ld	(de),a
	inc	hl
	inc	d
	ld	e,b
	ldi
	ldi
	ldi
	ld	a,(hl)
	ld	(de),a

	ret

; 0xb9ab`0xb9bd
; ENERGY`
;
	org	$b9ab

	ld	hl,$73e4	; (57*4,178)VRAMAhX
	jr	$b9be

; 0xb9be`
; ̂܂܎gp
;
	org	$b9be
	db	$ff

; 0xb9c7`0xb9c9
; ENERGY`
;
	org	$b9c7
	ld	de,$1530+2	; ENERGYwi

; 0xb9ca`
; ̂܂܎gp
;
	org	$b9ca
	db	$ff

; 0xb9cd`0xb9d0
; ENERGY`
;
	org	$b9cd
	ret

; 0xb9d1`
; ̂܂܎gp
;
	org	$b9d1
	db	$ff

; 0xb9d9`0xb9db
; ENERGY`
;
	org	$b9d9
	ld	de,$1500+2	; ENERGY

; 0xb9dc`
; ̂܂܎gp
;
	org	$b9dc
	db	$ff

; 0xb9de`0xb9e0
; ENERGY`
;
	org	$b9de
	ld	de,$1520+2	; ENERGY

; 0xb9e1`
; ̂܂܎gp
;
	org	$b9e1
	db	$ff

; 0xb9e3`0xba01
; ENERGY`
;
	org	$b9e3
	ld	de,$1510+2	; ENERGY

	org	$b9e6
	ld	(DRAWENERGY_L.pat+1),de
	ld	(DRAWENERGY_R.pat+1),de
	ld	b,a
	ld	a,h
	cp	$1a
	jp	c,DRAWENERGY_R
	jp	DRAWENERGY_L

; 0xba06`0xba1c
; 탌x̕\
;
	org	$ba06
	call	CALCVRAM
	ex	de,hl
	jr	$ba1f

; 0xba1d`
; ̂܂܎gp
;
	org	$ba1d
	db	$ff

; 0xba25`0xba27
; 탌x̕\
;
	org	$ba25
	call	DRAWWEAPONSUB

; 0xba28`
; ̂܂܎gp
;
	org	$ba28
	db	$ff

; 0xba34`0xba39
; 탌x̕\
;
	org	$ba34
	ld	hl,$15a0	; 탌xwi
	call	DRAWWEAPONSUB

; 0xba3a`
; ̂܂܎gp
;
	org	$ba3a
	db	$ff

; 0xba5d`0xba9e
; wi̐`
;
	org	$ba5d
DRAWSTAR:
	ld	a,$e2		; rbg}bv[hɐݒ
	out	($c8),a
	ld	hl,$bada

	ld	a,$0d		; 
	ld	(STARSUB.pat1+1),a
	ld	(STARSUB.pat2+1),a
	ld	bc,-12		; ړR
	ld	a,$1a		; ^C}f[^
	ld	(STARSUB.tim+1),a
	call	$ba9f

	xor	a		; 
	ld	(STARSUB.pat1+1),a
	ld	bc,-8		; ړQ
	ld	a,$28		; ^C}f[^
	ld	(STARSUB.tim+1),a
	call	$ba9f

	ld	a,$0d		; /
	ld	(STARSUB.pat1+1),a
	ld	a,$02		; /
	ld	(STARSUB.pat2+1),a
	ld	bc,-4		; ړP
	ld	a,$50		; ^C}f[^
	ld	(STARSUB.tim+1),a
	call	$ba9f

	jp	DRAW4x2.end	; ڃANZX[hɖ߂

; 0xba9f`
; ̂܂܎gp
;
	org	$ba9f
	db	$ff


; 0xbaaf`0xbad9
; wi̐`
;
	org	$baaf
STARSUB:
	ld	a,(hl)		; PځFYW
	out	($ce),a
	inc	hl
	ld	e,(hl)		; QځFXW/2
	ld	d,$00
	ex	de,hl
	add	hl,hl
	ld	(hl),$00	; 
	inc	hl
	inc	hl
	ld	(hl),$00	; 
	ex	de,hl
	inc	hl
	dec	(hl)		; RځF^C}
	jr	z,.tful		; ^C}Wv
	ex	de,hl
	add	hl,bc
.pat1:	ld	(hl),$00	; `
	dec	hl
	dec	hl
.pat2:	ld	(hl),$00	; `
	ex	de,hl
	srl	d
	rr	e
.end:	dec	hl
	ld	(hl),e		; QځFXW/2
	dec	hl
	ret

.tful:
.tim:	ld	(hl),$00	; RځF^C}Đݒ
	ld	e,$9e		; ĐݒpXW
	jr	.end


; 0xbada`0xbb51
; wi̐`if[^j
;
	org	$bada

	db	$14,$6E,$12,$14,$9E
	db	$28,$3C,$10,$28,$9E
	db	$2E,$1C,$4c,$2E,$9E
	db	$45,$64,$32,$45,$9E
	db	$4B,$8C,$16,$4B,$9E
	db	$64,$9C,$21,$64,$9E
	db	$78,$32,$08,$78,$9E
	db	$8C,$50,$0d,$8C,$9E

	db	$2A,$2A,$0e,$2A,$9E
	db	$4B,$5C,$0f,$4B,$9E
	db	$2E,$1C,$26,$2E,$9E
	db	$45,$64,$19,$45,$9E
	db	$64,$5A,$16,$64,$9E
	db	$7F,$1E,$07,$7F,$9E
	db	$8A,$86,$21,$8A,$9E
	db	$A0,$3C,$0f,$A0,$9E

	db	$2A,$2A,$15,$2A,$9E
	db	$4B,$5C,$2e,$4B,$9E
	db	$60,$9C,$4e,$60,$9E
	db	$8E,$3A,$1d,$8E,$9E
	db	$98,$64,$32,$98,$9E
	db	$A2,$3C,$1e,$A2,$9E
	db	$78,$32,$02,$78,$9E
	db	$8C,$50,$04,$8C,$9E


; 0xbb52`0xbb6b
; eLXgRAMNA
; gpȂ
;
	org	$bb52
	jr	$bb6c

;
; SPACE/TRIGGER܂ő҂
;
WAITTRG:
.lp1:
	ld	a,(GAMEDATA)
	and	$10
	jr	z,.lp1
	ret


; 0xbb6c`
; ̂܂܎gp
;
	org	$bb6c
	db	$ff

; 0xbb9b`0xbbc1
; SsPʂœhԂ
;
; A'FhF
; B FcWi/4j
;
	org	$bb9b

	ld	c,0
	call	CALCVRAM_L
	push	bc
	ld	b,0		; 256 + 256
	call	LINE4SUB
	call	LINE4SUB
	pop	bc
	call	CALCVRAM_R
	push	hl
	ld	b,64
	call	LINE4SUB
	pop	hl
	inc	h
	ld	b,64

LINE4SUB:
	ex	af,af'
	ld	e,a
	ex	af,af'
.lp1:
	ld	(hl),e
	inc	hl
	djnz	.lp1
	ret

; 0xbbc2`
; ̂܂܎gp
;
	org	$bbc2
	db	$ff

; 0xbbd5`0xbc27
; t@C̓e`
;
; CFYWi0`99j
; BFXWi0`159j
;
; (0xBBC7)FBp^[+0s
; (0xBBC6)FBp^[+1s
; (0xBBC3)FRp^[+0s
; (0xBBC2)FRp^[+1s
; (0xBBC5)FGp^[+0s
; (0xBBC4)FGp^[+1s
; B̎A4rbgL
; B̎A4rbgL
;
	org	$bbd5
FILEDRAW4x2:
	call	CONVCOLOR

	ld	a,b
	and	$fe
	ld	l,a
	ld	h,0
	add	hl,hl

	bit	0,b
	jr	nz,.noinc
	inc	l
.noinc:

	ld	de,DRWDAT
	ld	a,c
	add	a,a		; +0s
	call	DRAWLH
	ld	a,c
	add	a,a
	inc	a		; +1s
	call	DRAWLH

	ret

;
; t@C̓e`Tu
;
DRAWLH:
	out	($ce),a

	ld	a,(de)
	inc	de
	call	ODDCHECK
	or	(hl)
	ld	(hl),a		; v[#1
	inc	l
	inc	l

	ld	a,(de)
	inc	de
	call	ODDCHECK
	or	(hl)
	ld	(hl),a		; v[#0
	dec	l
	dec	l

	ret

;
; t@C̓e`Tu
;
ODDCHECK:
	bit	0,b
	ret	z
	rrca
	rrca
	rrca
	rrca
	ret


; 0xbc28`
; ̂܂܎gp
;
	org	$bc28
	db	$ff

; 0xbc9c`0xbca5
; t@Ce`悷
;
	org	$bc9c
	nop
	ld	(FILEDRAWLOW.ysz+1),a
	ld	(FILEDRAWHIGH.ysz+1),a
	ld	(FILEDRAWBOX.ysz+1),a

; 0xbca6`
; ̂܂܎gp
;
	org	$bca6
	db	$ff

; 0xbcc1`0xbcc4
; t@Ce`悷
;
	org	$bcc1
	ld	a,e
	ld	(FILEDRAWLOW.xpos+1),a

; 0xbcc5`
; ̂܂܎gp
;
	org	$bcc5
	db	$ff

; 0xbcc9`0xbccc
; t@Ce`悷
;
	org	$bcc9
	ld	a,e
	ld	(FILEDRAWHIGH.xpos+1),a

; 0xbccd`
; ̂܂܎gp
;
	org	$bccd
	db	$ff

; 0xbcdc`0xbce3
; t@Ce`悷
;
	org	$bcdc
	ld	a,e
	ld	(FILEDRAWLOW.xpos+1),a
	inc	a
	ld	(FILEDRAWHIGH.xpos+1),a

; 0xbce4`
; ̂܂܎gp
;
	org	$bce4
	db	$ff

; 0xbced`0xbcf8
; t@Ce`悷
;
	org	$bced
	ld	(FILEDRAWBOX.xsz+1),a
	jr	$bcf9

; 0xbcf9`
; ̂܂܎gp
;
	org	$bcf9
	db	$ff

; 0xbd05`0xbd1e
; t@Ce`悷
;
	org	$bd05
	ld	a,e
	ld	(FILEDRAWLOW.xpos+1),a
	inc	a
	ld	(FILEDRAWBOX.xpos+1),a
	ld	e,a
	ld	a,(FILEDRAWBOX.xsz+1)
	dec	a
	ld	(FILEDRAWBOX.xsz+1),a
	add	a,e
	ld	(FILEDRAWHIGH.xpos+1),a
	jr	$bd1f

; 0xbd1f`
; ̂܂܎gp
;
	org	$bd1f
	db	$ff

; 0xbd29`0xbd2c
; t@Ce`悷
;
	org	$bd29
	ld	a,e
	ld	(FILEDRAWBOX.xpos+1),a

; 0xbd2d`
; ̂܂܎gp
;
	org	$bd2d
	db	$ff

; 0xbd3b`0xbd42
; t@Ce`悷
;
	org	$bd3b
	ld	a,e
	ld	(FILEDRAWLOW.xpos+1),a
	inc	a
	ld	(FILEDRAWBOX.xpos+1),a

; 0xbd43`
; ̂܂܎gp
;
	org	$bd43
	db	$ff

; 0xbd4a`0xbd57
; t@Ce`悷
;
	org	$bd4a
	ld	a,e
	ld	(FILEDRAWBOX.xpos+1),a
	ld	a,(FILEDRAWBOX.xsz+1)
	add	a,e
	ld	(FILEDRAWHIGH.xpos+1),a
	jr	$bd58

; 0xbd58`
; ̂܂܎gp
;
	org	$bd58
	db	$ff

; 0xbd5f`0xbd9e
; ciʂSrbgpj
;
	org	$bd5f
FILEDRAWLOW:
	call	CONVCOLOR

	ld	a,($bbc9)
	add	a,a
	ld	c,a

.xpos:	ld	hl,$0000
	add	hl,hl		; x2
	add	hl,hl		; x4

.ysz:	ld	b,$00
.lp1:
	ld	de,DRWDAT
	call	DRAWLOW
	inc	c
	call	DRAWLOW
	inc	c
	djnz	.lp1

	ret


; 0xbd9f`0xbdde
; ciʂSrbgpj
;
	org	$bd9f
FILEDRAWHIGH:
	call	CONVCOLOR

	ld	a,($bbc9)
	add	a,a
	ld	c,a

.xpos:	ld	hl,$0000
	add	hl,hl		; x2
	add	hl,hl		; x4
	inc	l

.ysz:	ld	b,$00
.lp1:
	ld	de,DRWDAT
	call	DRAWHIGH
	inc	c
	call	DRAWHIGH
	inc	c
	djnz	.lp1

	ret


; 0xbddf`0xbe12
; t@C̓e`
;
	org	$bddf
FILEDRAWBOX:
	call	CONVCOLOR

	ld	a,($bbc9)
	add	a,a
	ld	c,a

.xpos:	ld	hl,$0000
	add	hl,hl		; x2
	add	hl,hl		; x4

.xsz:	ld	a,$00
	ld	(.xsz1+1),a
	ld	(.xsz2+1),a

.ysz:	ld	a,$00
.lp1:
	ex	af,af'

	ld	de,DRWDAT
.xsz1:	ld	b,$00
	call	DRAWBOX
	inc	c

	ld	de,DRWDAT+2
.xsz2:	ld	b,$00
	call	DRAWBOX
	inc	c

	ex	af,af'
	dec	a
	jr	nz,.lp1

	ret

; 0xbe13`0xbe25
; YWVRAMAhXZoigpȂj
;
	org	$be13
	or	a
	ret

; 0xbe26`
; ̂܂܎gp
;
	org	$be26
	db	$ff

; 0xbf41`0xbf47
; t@C̓e`
;
	org	$bf41
	call	SETDRWVRAM
	call	SETDRWFILE
	nop

; 0xbf48`
; ̂܂܎gp
;
	org	$bf48
	db	$ff

; 0xbff7`0xbff9
; t@C̓e`
;
	org	$bff7
	jp	RETDRW

; 0xbffa`
; ̂܂܎gp
;
	org	$bffa
	db	$ff

; 0xc0aa`0xc0ad
; ʉ
;
	org	$c0aa
	ld	a,(CAPSDATA)
	or	a

; 0xc0ae`
; ̂܂܎gp
;
	org	$c0ae
	db	$ff

; 0xc1ca`0xc1cc
; ʃNA̍Ō̉
;
	org	$c1ca
	call	CLRSTOP

; 0xc1cd`
; ̂܂܎gp
;
	org	$c1cd
	db	$ff

; 0xc215`0xc220
; ʉgt@C
;
	org	$c215
	db	"window"	; t@CU
	db	"drw"		; gqR

; 0xc221`
; ̂܂܎gp
;
	org	$c221
	db	$ff

; 0xc263`0xc265
; 탌x̕\
;
	org	$c263
	ld	de,$1540	; Ԏlp

; 0xc266`
; ̂܂܎gp
;
	org	$c266
	db	$ff

; 0xc278`0xc27a
; 탌x̕\
;
	org	$c278
	ld	de,$1560	; lp

; 0xc27b`
; ̂܂܎gp
;
	org	$c27b
	db	$ff

; 0xc289`0xc28b
; 탌x̕\
;
	org	$c289
	ld	de,$1580	; lp

; 0xc28c`
; ̂܂܎gp
;
	org	$c28c
	db	$ff

; 0xc379`0xc393
; SPACE/TRIGGER̃`FbN
;
	org	$c379
CHKTRG:
	ld	a,(KEYDATA)
	ld	(STARTKEY),a
	cp	'A'
	jr	c,.next
	cp	'D'
	jp	c,GAMESTART

.next:
	ld	a,(GAMEDATA)
	and	$10		; SPACE
	jp	nz,GAMESTART

	ret


; 0xc394`0xc39e
; PAUSE
;
	org	$c394
	ld	a,(KEYDATA)
	cp	$1b		; ESC
	jr	nz,$c39f

	call	WAITTRG
	nop

; 0xc39f`
; ̂܂܎gp
;
	org	$c39f
	db	$ff

; 0xc3ab`0xc3ab
; Ԃ̕ύX
;
	org	$c3ab
	db	$70		; 0xB4

; 0xc3ac`
; ̂܂܎gp
;
	org	$c3ac
	db	$ff

; 0xc3bd`0xc3c0
; ݒ
;
	org	$c3bd
	call	PALETINIT
	nop

; 0xc3c1`
; ̂܂܎gp
;
	org	$c3c1
	db	$ff

; 0xc3e8`0xc3ea
; 탌x̕\
;
	org	$c3e8
	ld	de,$1540	; Ԏlp

; 0xc3eb`
; ̂܂܎gp
;
	org	$c3eb
	db	$ff

; 0xc3f4`0xc3f6
; 탌x̕\
;
	org	$c3f4
	ld	de,$1560	; lp

; 0xc3f7`
; ̂܂܎gp
;
	org	$c3f7
	db	$ff

; 0xc400`0xc402
; 탌x̕\
;
	org	$c400
	ld	de,$1580	; lp

; 0xc403`
; ̂܂܎gp
;
	org	$c403
	db	$ff

; 0xc447`0xc448
; ݒ
;
	org	$c447
	out	($a0),a

; 0xc449`
; ̂܂܎gp
;
	org	$c449
	db	$ff

; 0xc460`0xc463
; ݒ
;
	org	$c460
	ld	a,$bf
	out	($a1),a

; 0xc464`
; ̂܂܎gp
;
	org	$c464
	db	$ff

; 0xc484`0xc486
; ݒiʑIj
;
	org	$c484
	call	MENSEL

; 0xc487`
; ̂܂܎gp
;
	org	$c487
	db	$ff

; 0xcff1`0xcff2
; BEEP炷Ȃ
;
	org	$cff1
	nop
	nop

; 0xcff3`
; ̂܂܎gp
;
	org	$cff3
	db	$ff

; 0xd01b`0xd01d
; @̒ep^[
;
	org	$d01b
	ld	de,$15d8	; 

; 0xd01e`
; ̂܂܎gp
;
	org	$d01e
	db	$ff

; 0xd024`0xd025
; BEEP~߂遨Ȃ
;
	org	$d024
	nop
	nop

; 0xd026`
; ̂܂܎gp
;
	org	$d026
	db	$ff

; 0xd05c`0xd05d
; BEEP炷Ȃ
;
	org	$d05c
	nop
	nop

; 0xd05e`
; ̂܂܎gp
;
	org	$d05e
	db	$ff

; 0xd096`0xd097
; BEEP~߂遨Ȃ
;
	org	$d096
	nop
	nop

; 0xd098`
; ̂܂܎gp
;
	org	$d098
	db	$ff

; 0xd184`0xd19e
; eLXgRAMNAigpȂj
;
	org	$d184
	ret

; VRAMAhXiEjZo
; BFYWi/8j
; CFXWi/4j
; RETURN
; HLFVRAMAhX
;
CALCVRAM_R:

	push	af

	ld	a,b

	rrca
	rrca				; Y5-0 => Y1-0,,Y5-2
	and	$c0			; Y1-0 => b7,6
	ld	l,a

	ld	a,c
	add	a,a
	add	a,a
	add	a,l
	ld	l,a

	ld	a,b
	rrca				; Y0,,Y5-1
	and	$1e			; Y5-2 => b4-1
	ld	h,a

	pop	af
	ret


; 0xd19f`
; ̂܂܎gp
;
	org	$d19f
	db	$ff

; 0xd1fa`0xd20a
; Ge
;
	org	$d1fa
	ld	e,$00		; Ge̐F
	call	DRAW4x2		; Ge\
	jr	$d20b

; 0xd20b`
; ̂܂܎gp
;
	org	$d20b
	db	$ff

; 0xd222`0xd231
; Ge`
;
	org	$d222
	ld	e,$0f		; Ge̐F
	call	DRAW4x2		; Ge\
	jr	$d232

; 0xd232`
; ̂܂܎gp
;
	org	$d232
	db	$ff

; 0xd359`0xd38c
; XYWGeVRAMAhXZo
;($d712)FXWi/4j
;($d713)FYWi/2j
; RETURN
;($d714)FXW
;($d716)FYW
;
;
	org	$d359
	push	hl
	ld	a,($d712)
	ld	h,a
	and	$fe
	rrc	h
	ccf
	ld	l,a
	ld	h,0
	adc	hl,hl		; x2
	ld	($d714),hl
	ld	a,($d713)
	add	a,a
	ld	($d716),a
	pop	hl
	ret

; 0xd38d`
; ̂܂܎gp
;
	org	$d38d
	db	$ff

; 0xd398`0xd39c
; Ge
;
	org	$d398
	ld	e,$00		; Ge̐F
	call	DRAW4x2		; Ge\

; 0xd39d`
; ̂܂܎gp
;
	org	$d39d
	db	$ff

; 0xda84`0xda8d
; @ړ
;
	org	$da84
	ld	a,(GAMEDATA)
	and	$0f
	jp	z,$dbf0
	xor	$ff

; 0xda8e`
; ̂܂܎gp
;
	org	$da8e
	db	$ff

; 0xdab1`0xdae4
; @ړigpɂȂj
;
	org	$dab1

; 0xdae5`
; ̂܂܎gp
;
	org	$dae5
	db	$ff

; 0xdd8b`0xdd8d
; 탌x̕\
;
	org	$dd8b
	ld	de,$1540	; Ԏlp

; 0xdd8e`
; ̂܂܎gp
;
	org	$dd8e
	db	$ff

; 0xdda6`0xdda8
; 탌x̕\
;
	org	$dda6
	ld	de,$1560	; lp

; 0xdda9`
; ̂܂܎gp
;
	org	$dda9
	db	$ff

; 0xddc1`0xddc3
; 탌x̕\
;
	org	$ddc1
	ld	de,$1580	; lp

; 0xddc4`
; ̂܂܎gp
;
	org	$ddc4
	db	$ff

; 0xdeb0`0xdec3
; ύX
;
	org	$deb0
	ld	a,(GAMEDATA)
	and	$20
	jr	nz,$dec7
	ld	(hl),$ff
	jr	$def1

; 0xdec4`
; ̂܂܎gp
;
	org	$dec4
	db	$ff

; 0xdef4`0xdf06
; @̒e
;
	org	$def4
	ld	a,(GAMEDATA)
	and	$10
	jr	nz,$df08
	ld	(hl),$ff
	ret

; 0xdf07`
; ̂܂܎gp
;
	org	$df07
	db	$ff

; 0xe02b`0xe02d
; @̒ep^[
;
	org	$e02b
	ld	de,$15d8	; 

; 0xe02e`
; ̂܂܎gp
;
	org	$e02e
	db	$ff

; 0xe08f`0xe091
; @̒ep^[
;
	org	$e08f
	ld	de,$15c0	; @eiWIDEj

; 0xe092`
; ̂܂܎gp
;
	org	$e092
	db	$ff

; 0xe0be`0xe0c0
; @̒ep^[
;
	org	$e0be
	ld	de,$15d8	; 

; 0xe0c1`
; ̂܂܎gp
;
	org	$e0c1
	db	$ff

; 0xe0d8`0xe0da
; @̒ep^[
;
	org	$e0d8
	ld	de,$15c8	; @eiTAILj

; 0xe0db`
; ̂܂܎gp
;
	org	$e0db
	db	$ff

; 0xe0e8`0xe0ea
; @̒ep^[
;
	org	$e0e8
	ld	de,$15d0	; @eiTAILOj

; 0xe0eb`
; ̂܂܎gp
;
	org	$e0eb
	db	$ff

; 0xe0fb`0xe0fd
; @̒ep^[
;
	org	$e0fb
	ld	de,$15c8	; @eiTAILj

; 0xe0fe`
; ̂܂܎gp
;
	org	$e0fe
	db	$ff

; 0xe111`0xe113
; @̒ep^[
;
	org	$e111
	ld	de,$15c8	; @eiTAILj

; 0xe114`
; ̂܂܎gp
;
	org	$e114
	db	$ff

; 0xe6a0`
; ǉvO
	org	$e6a0

;
; ENERGY`
;
DRAWENERGY_L:
	ex	de,hl
.lp2:
	push	de
	ld	c,5*3
.pat:	ld	hl,$0000
	ld	a,e
.lp1:
	ld	e,a
	ldi
	ldi
	ldi
	ldi
	dec	de
	inc	d

	dec	c		; 4x2hbg݂ŁAc -= 5
	jr	nz,.lp1
	pop	de

	inc	e
	inc	e
	inc	e
	inc	e
	jp	z,DRAWENERGY_R_CNT

	djnz	.lp2
	ex	de,hl
	ret


DRAWENERGY_R:
	ex	de,hl
.lp2:
	push	de
	ld	c,$ff
.pat:	ld	hl,$0000
	ld	a,e

	ld	e,a
	ldi
	ldi
	ldi
	ldi
	dec	de
	dec	d

	add	a,$40
	jr	nc,.n1
	inc	d
	inc	d
.n1:
	ld	e,a
	ldi
	ldi
	ldi
	ldi
	dec	de
	inc	d
	ld	e,a
	ldi
	ldi
	ldi
	ldi
	dec	de
	inc	d

	pop	de
	inc	e
	inc	e
	inc	e
	inc	e
.cont:
	djnz	.lp2
	ex	de,hl
	ret

DRAWENERGY_R_CNT:
	ld	de,$1700	; (256,178)
	jr	DRAWENERGY_R.cont

;
; Pi16x8j`iEj
; HLFp^[AhX
; DEFVRAMAhX
;
DRAW16x8_R:

	ld	b,2
.lp2:
	push	de
	ld	c,9*2
	ld	a,e
.lp1:
	ld	e,a
	ldi
	ldi
	ldi
	ldi
	dec	de
	inc	d
	ld	e,a
	ldi
	ldi
	ldi
	ldi
	dec	de
	dec	d

	add	a,$40
	jr	nc,.n1
	inc	d
	inc	d
.n1:
	dec	c		; 4x4hbg݂ c -= 9
	jr	nz,.lp1

	pop	de
	inc	e
	inc	e
	inc	e
	inc	e
.cont:
	djnz	.lp2
	ret

DRAW16x8_R_CNT:
	call	CALCVRAM_L2R

	jr	DRAW16x8_R.cont

;
; 32x16`iEj
; HLFp^[AhX
; DEFVRAMAhX
;
DRAW32x16_R:

	ld	b,4
.lp2:
	push	de
	ld	c,9*4
	ld	a,e
.lp1:
	ld	e,a
	ldi
	ldi
	ldi
	ldi
	dec	de
	inc	d
	ld	e,a
	ldi
	ldi
	ldi
	ldi
	dec	de
	dec	d

	add	a,$40
	jr	nc,.n1
	inc	d
	inc	d
.n1:
	dec	c		; 4x4hbg݂ c -= 9
	jr	nz,.lp1

	pop	de
	inc	e
	inc	e
	inc	e
	inc	e
.cont:
	djnz	.lp2
	ret

DRAW32x16_R_CNT:
	call	CALCVRAM_L2R

	jr	DRAW32x16_R.cont

;
; 64x32`iEj
; HLFp^[AhX
; DEFVRAMAhX
;
DRAW64x32_R:

	ld	b,8
.lp2:
	push	de
	ld	c,9*8
	ld	a,e
.lp1:
	ld	e,a
	ldi
	ldi
	ldi
	ldi
	dec	de
	inc	d
	ld	e,a
	ldi
	ldi
	ldi
	ldi
	dec	de
	dec	d

	add	a,$40
	jr	nc,.n1
	inc	d
	inc	d
.n1:
	dec	c		; 4x4hbg݂ c -= 9
	jr	nz,.lp1

	pop	de
	inc	e
	inc	e
	inc	e
	inc	e
.cont:
	djnz	.lp2
	ret

DRAW64x32_R_CNT:
	call	CALCVRAM_L2R

	jr	DRAW64x32_R.cont

;
; `iEj
; HLFp^[AhX
; DEFVRAMAhX
;
ERASEHxL_R:

.lp2:
	push	hl
	ld	e,c		; c[v
	ld	a,l
.lp1:
	ld	l,a
	ld	(hl),d
	inc	l
	ld	(hl),d
	inc	l
	ld	(hl),d
	inc	l
	ld	(hl),d
	inc	h

	ld	l,a
	ld	(hl),d
	inc	l
	ld	(hl),d
	inc	l
	ld	(hl),d
	inc	l
	ld	(hl),d
	dec	h

	add	a,$40
	jr	nc,.n1
	inc	h
	inc	h
.n1:
	dec	e
	jr	nz,.lp1

	pop	hl
	inc	l
	inc	l
	inc	l
	inc	l
.cont:
	djnz	.lp2
	ret

ERASEHxL_R_CNT:
	ex	de,hl
	call	CALCVRAM_L2R
	ex	de,hl

	jr	ERASEHxL_R.cont

;
; VRAMAhXEZo
; DFVRAMAhX
; DEFVRAMEAhX
;
CALCVRAM_L2R:
	ld	a,d
	sub	$1a
	srl	a
	ld	d,a

	rrca
	rrca				; Y5-0 => Y1-0,,Y5-2
	and	$c0			; Y1-0 => b7,6
	ld	e,a

	ld	a,d
	rrca				; Y0,,Y5-1
	and	$1e			; Y5-2 => b4-1
	ld	d,a

	ret

;
; 탌x\
;
DRAWWEAPONSUB:
	ld	b,2
.lp2:
	push	de
	ld	c,5*4
	ld	a,e
.lp1:
	ld	e,a
	ldi
	ldi
	ldi
	ldi
	dec	de
	inc	d

	dec	c		; 4x2hbg݂ c -= 5
	jr	nz,.lp1
	pop	de

	inc	e
	inc	e
	inc	e
	inc	e

	djnz	.lp2
	ret

; ʃNA̍Ō̉
;
CLRSTOP:
	call	$8d03		; 
	ld	a,($e135)
	ret

;
; Ge\i4x2hbgj
;
DRAW4x2:
	ld	a,$e2		; rbg}bv[hɐݒ
	out	($c8),a

	ld	a,($d716)	; YW
	out	($ce),a
	ld	hl,($d714)	; XW
	ld	(hl),e
	inc	hl
	inc	hl
	ld	(hl),e
	inc	a
	out	($ce),a
	ld	(hl),e
	dec	hl
	dec	hl
	ld	(hl),e
.end:
	ld	a,$ea		; ڃANZX[hɐݒ
	out	($c8),a
	ret

;
; ʑIpL[
;
MENSEL:
	ld	a,(STARTKEY)
	sub	'A'
	jr	c,.end
	inc	a
	cp	4
	jr	nc,.end
	ret
.end:
	xor	a
	ret

STARTKEY:
	db	$00

;
; Q[X^[g
;
GAMESTART:
	xor	a
	ld	($e130),a
	ld	sp,($c2fe)
	jp	$c001

;
; drw`掞VRAMݒ
;
SETDRWVRAM:
	ld	a,$e2		; rbg}bv[hɐݒ
	out	($c8),a

		;
		;0x0000`0x1FFF̓ǂݏoVRAMɂ
		;
	ld	a,$00
	out	($60),a

		;
		;0x2000`0x7FFF݂̏ORAMɂ
		;
	ld	a,$22
	out	($69),a
	add	a,2
	out	($6a),a
	add	a,2
	out	($6b),a

	pop	af
	ld	(RETDRW.sppt+1),sp
	push	af
	ret


;
; drw`掞VRAMݒ߂
;
RETDRW:
		;
		;0x0000`0x1FFF̓ǂݏoORAMɂ
		;
	ld	a,$20
	out	($60),a

		;
		;0x2000`0x7FFF݂̏VRAMɂ
		;
	ld	a,$02
	out	($69),a
	add	a,2
	out	($6a),a
	add	a,2
	out	($6b),a

	ld	a,$ea		; ڃANZX[hɐݒ
	out	($c8),a

.sppt:	ld	sp,$0000

	ret

;
; t@C̓e`Tu
;
; (0xBBC7)FBp^[+0s
; (0xBBC6)FBp^[+1s
; (0xBBC3)FRp^[+0s
; (0xBBC2)FRp^[+1s
; (0xBBC5)FGp^[+0s
; (0xBBC4)FGp^[+1s
;
CONVCOLOR:
	push	bc
	push	ix

	ld	ix,$bbc2
	ld	b,(ix+1)	; R +0
	ld	a,(ix+5)	; B +0
	or	b
	cpl
	and	(ix+3)		; G +0
	ld	c,a
	or	b
	ld	(DRWDAT+0),a	; v[#1 +0s
	ld	a,c
	or	(ix+5)		; B +0
	ld	(DRWDAT+1),a	; v[#0 +0s

	ld	b,(ix+0)	; R +1
	ld	a,(ix+4)	; B +1
	or	b
	cpl
	and	(ix+2)		; G +1
	ld	c,a
	or	b
	ld	(DRWDAT+2),a	; v[#1 +1s
	ld	a,c
	or	(ix+4)		; B +1
	ld	(DRWDAT+3),a	; v[#0 +1s

;;
;; eXgp
;;
;	ld	ix,$bbc2
;	ld	a,(ix+1)	; R +0
;	ld	(DRWDAT+0),a	; v[#1 +0s
;	ld	a,(ix+5)	; B +0
;	ld	b,a
;;	or	(ix+3)		; G +0
;	ld	(DRWDAT+1),a	; v[#0 +0s
;
;	ld	a,(ix+0)	; R +1
;	ld	(DRWDAT+2),a	; v[#1 +1s
;	ld	a,(ix+4)	; B +1
;	ld	b,a
;;	or	(ix+2)		; G +1
;	ld	(DRWDAT+3),a	; v[#0 +1s

	pop	ix
	pop	bc
	ret

DRWDAT:
	db	$00		; v[#1 +0s
	db	$00		; v[#0 +0s
	db	$00		; v[#1 +1s
	db	$00		; v[#0 +1s

;
; cTu
;
DRAWLOW:
	ld	a,c
	out	($ce),a

	ld	a,(de)
	inc	de
	or	(hl)
	ld	(hl),a		; v[#1
	inc	l
	inc	l

	ld	a,(de)
	inc	de
	or	(hl)
	ld	(hl),a		; v[#0
	dec	l
	dec	l

	ret

;
; cTu
;
DRAWHIGH:
	ld	a,c
	out	($ce),a

	ld	a,(de)
	inc	de
	rrca
	rrca
	rrca
	rrca
	or	(hl)
	ld	(hl),a		; v[#1
	inc	l
	inc	l

	ld	a,(de)
	inc	de
	rrca
	rrca
	rrca
	rrca
	or	(hl)
	ld	(hl),a		; v[#0
	dec	l
	dec	l

	ret

;
; ``悷Tu
;
DRAWBOX:
	ld	a,c
	out	($ce),a

	push	hl
.lp1:
	ld	a,(de)
	or	(hl)
	ld	(hl),a		; v[#1
	inc	l

	ld	a,(de)
	inc	de
	rrca
	rrca
	rrca
	rrca
	or	(hl)
	ld	(hl),a		; v[#1
	inc	l

	ld	a,(de)
	or	(hl)
	ld	(hl),a		; v[#0
	inc	l

	ld	a,(de)
	dec	de
	rrca
	rrca
	rrca
	rrca
	or	(hl)
	ld	(hl),a		; v[#0
	inc	hl

	djnz	.lp1

	pop	hl
	ret

;
; pbg̏
;
PALETINIT:
	ld	a,$00
	out	($40),a		; pbgݒi"11"=j
;	ld	a,$06
;	out	($41),a		; pbgݒi"10"=j
	ld	a,$0a
	out	($41),a		; pbgݒi"10"=Fj
	ld	a,$05
	out	($42),a		; pbgݒi"01"=ԁj
	ld	a,$07
	out	($43),a		; pbgݒi"00"=j
	ret

;
; vȌI
;
	org	$e8ff
	db	$ff


end

